unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.TeEngine,
  VCLTee.Series, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TBarSeries;
  private
    { Private declarations }
    FDrawRedIndexes: TList;
    procedure ChartBottomAxisDrawLabel(Sender:TChartAxis;
      var aX,aY,aZ:Integer; var aText:String; var aDrawLabel:Boolean);
  public
    { Public declarations }
    constructor Create(aOwner: TComponent); override;
    destructor Destroy; override;
  end;

var
  Form1: TForm1;

implementation

uses
  VCLTee.TeeConst;

{$R *.dfm}

{ TForm1 }

procedure TForm1.ChartBottomAxisDrawLabel(Sender: TChartAxis; var aX, aY,
  aZ: Integer; var aText: String; var aDrawLabel: Boolean);
var
  I: Integer;
  lCalcXPos: Integer;
  lChart: TChart;
  lIdx: Integer;
  lMinOffBy: Integer;
  lOffBy: Integer;
  lSrs: TChartSeries;
begin
  Assert(Sender.ParentChart is TChart);
  lChart := TChart(Sender.ParentChart);

  if SameText(lChart.BottomAxis.Title.Caption, aText) then
    exit;

  if lChart.SeriesCount > 0 then
  begin
    lSrs := lChart.Series[0];
    lIdx := -1;
    lMinOffBy := MaxInt;
    for I := lSrs.Count - 1 downto 0 do
    begin
      lCalcXPos := lSrs.CalcXPos(I);
      lOffBy := abs(aX - lCalcXPos);
      if (lOffBy < lMinOffBy) then
      begin
        lIdx := I;
        lMinOffBy := lOffBy;
      end;
    end;

    if (lIdx > -1) and (FDrawRedIndexes.IndexOf(TObject(lIdx)) > -1) then
    begin
      lChart.Canvas.Font.Color := clRed;
      lChart.Canvas.Font.Style := [fsBold];
    end;
  end;
end;

constructor TForm1.Create(aOwner: TComponent);
var
  lValue: Double;
  I: Integer;
begin
  inherited;

  Caption := TeeMsg_Version;

  FDrawRedIndexes := TList.Create;

  SEries1.Clear;
  lValue := 1000.0;
  for I := 0 to 19 do
  begin
    Series1.Add(lValue);
    lValue := lValue * 1.03;
    if (I mod 2) = 0 then
      FDrawRedIndexes.Add(TObject(I));
  end;

  Chart1.BottomAxis.OnDrawLabel := ChartBottomAxisDrawLabel


end;

destructor TForm1.Destroy;
begin
  FDrawRedIndexes.Free;
  inherited;
end;

end.
